<template>
  <v-container>
    <!-- <h2 class="secondary--text" align="center">
       Proves de {{category.name}}
    </h2>

    <v-divider class="mt-2"></v-divider> -->

    <div class="mt-2" v-if="noCompleteProves.length == 0">
      <v-alert type="info" color="green">
        <p>Heu completat totes les proves d'aquesta categoria. Enhorabona!</p>
      </v-alert>
    </div>

    <!-- <p>Completadas</p>
      {{userCompleted}}


    <p>No completadas</p>
      {{noCompleteProves}} -->


      

    <v-row class="mt-2">
      <v-col cols="6" sm="4" md="4" lg="3" xl="3" v-for="prove in noCompleteProves" :key="prove.id">
        <app-ui-nav-card-prove :prove="prove"></app-ui-nav-card-prove>
      </v-col>
    </v-row>

  
   
  </v-container>
</template>

<script>


export default {

  data() {
    return {
    
    };
  },
  computed:{  // TRAE EL NOMBRE DE LA CATEGORIA
    category(){
       const slug = this.$route.params.category
       return this.$store.getters.readCategories.find(category => category.slug == slug)
    },
    userCompleted() {
      //creo un array vacio, para asegurarme que siempre devuelvo un array
      let completed = []
      //pedimos las recetas completadas del usuario desde el vuex
      const userCompleted = this.$store.getters["user/completed"]
      //una vez este seguro que userCompleted es un array 
      if (Array.isArray(userCompleted)){
        //devuelvo solo el id de cada una con la ayuda del array.map()
        completed = userCompleted.map(item => item.id)
      }
      return completed
    },
     noCompleteProves(){
      //creo un array vacio
      let noCompleted = []
      //llamo mi otro array recipes que vienen del async asyncData y lo asigno como valor a mi array vacio
      //realizo un filtro donde chequeo si el id de cada prove coincide con el array numerico de las completadas del usuario
      noCompleted = this.proves.filter(prove => !this.userCompleted.includes(prove.id))
      return noCompleted
    },
  },
  async asyncData({app, route}){
    const slug = route.params.category
    const client = app.apolloProvider.defaultClient
    const query = {
      query:require("../../graphql/proves.gql"),
      variables:{slug}
    }
    let proves = []
    await client.query(query).then(data => {
      proves = data.data.proves
    }).catch(e => console.log(e))

    proves.sort(function (a, b){
        return (a.order - b.order)})

    console.log(proves)

    return { proves }
  },
  async mounted(){
    // if(this.$auth.loggedIn && this.$store.getters['user/completed'] == null){
    //   console.log('call completed')
    //   await this.$store.dispatch("user/getCompleted")
    // }
    this.$store.dispatch("user/getCompleted")
  }
};
</script>

<style scoped>

.container {
  background-image: url("https://i.ibb.co/5MTKvcz/Fons-Sense-Muntanya.png");
  background-size: cover;
  background-position: center;
  height: 100%;
}


  
</style>

 